#pragma once

#include "MidiDocument.h"
#include "MetaMidiEvent.h"
#include <string>

class MidiReader
{
	static constexpr const char TrackChunkLabel[] = "MTrk";
	static constexpr const char HeaderLabel[] = "MThd";
	MidiDocument mDocument;
	unsigned mTrackByteCount;

public:

	MidiReader();

	void Read(const std::string& path);

private:

	bool ProcessHeader(std::ifstream& file);

	bool ProcessTrackChunk(std::ifstream& file);

	bool ProcessEvent(std::ifstream& file);

	bool ProcessMetaEvent(std::ifstream& file, MetaMidiEvent& event);

	int ProcessTimeDelta(std::ifstream& file);
};
