#pragma once
#include <memory>
#include <vector>
#include <string>

class XmlAttribute
{

	std::string mName;
	std::string mValue;

public:

	XmlAttribute(const std::string& name);

	static std::shared_ptr<XmlAttribute> Create(const std::string& name);

	void SetValue(const std::string& value);

	std::string GetName() const;

	std::string GetValue() const;
};

using XmlAttributePtr = std::shared_ptr<XmlAttribute>;
