#pragma once
#include <memory>
#include <vector>
#include "XmlElement.h"

class XmlProlog : public XmlElement
{
public:

	enum class Version{
		V1_0
	};

	enum class Encoding{
		UTF8
	};

private:

	Version mVersion;
	Encoding mEncoding;
	std::string mTagName;

public:
	XmlProlog(const std::string& tagName);

	static std::shared_ptr<XmlProlog> Create(const std::string& tagName);
	void Update();
	Encoding GetEncoding() const;
	Version GetVersion() const;

	void SetEncoding(const std::string& encoding);
	void SetVersion(const std::string& version);
};

using XmlPrologPtr = std::shared_ptr<XmlProlog>;
